#ifndef _DE_H
#define _DE_H

#if MAXPOP < 1000
#define POOLSIZE 2000
#else
#define POOLSIZE 4000
#endif

// Important paramaters for running DE
extern int     DEvariant;
extern double  F, CR;
extern int     NP;

extern int    imin;         // index to member with the best cost (obj. func. val.)
extern double mincost;      // obj. func. val. of the best
extern double cost[MAXPOP]; // objective function values (f.)
extern double trial_cost;   // f. of the trial vector
extern double best[MAXDIM], bestit[MAXDIM];
extern double *curpop[MAXPOP], *nxtpop[MAXPOP], *pswap;

// Function prototypes declaration
void   allocate_de_memory();
void   deallocate_de_memory();
void   reset_de();
double de();
static void   differential_mutation(int i);
double DEevaluate(double x[]);
void   dcopy(int D, double dest[], double source[]);

#endif