#define _CRT_SECURE_NO_DEPRECATE 1 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <sys/timeb.h>
#include "rand.h"
#include "main.h"
#include "global.h"
#include "de.h"
#include "function.h"

// ˹Ϳѧѹ
char  *fname[] = {"GRN-5d", "F1-Sphere"};

enum  algo algorithm;
char  *functName;
char  description[100];
char  *stratename;
char  *mutname;
int   mode; // in case of DE's variants

// For logging purpose
int		logstep, logcount;
int		logstep2screen;  // no. of nfc for onscreen loggin.
int     logstep2file;    // no. of nfc for each file logging.
int     nshake[MAXRUN];
int     lognfc[MAXLOG*2]; // must at least +1 !!!
double  logval[MAXLOG*2]; // must at least +1 !!!
int     logc = 0;
double  answers[MAXRUN];
int     endnfc[MAXRUN];
char    filename[100];
FILE   *fo;

/***************************************************
 Generic variables for any optimizer
****************************************************/
// Define ranges, depending on the problem
double  mintab[MAXPROB+1] = { 0, -100 };
double  maxtab[MAXPROB+1] = { 0,  100 };

// Define initialization range, depending on the problem
double  min0tab[MAXPROB+1] = { 0,  100 };
double  max0tab[MAXPROB+1] = { 0,  100 };

// Definitions for running benchmark and some important running index
int     probnum;         //˹ѭ (ѧѹ) 
int     D;               //˹ԵԢͧѭ 
int     maxrun = MAXRUN; //˹ӹǹͺ٧ش㹡ѹ
int     nrun;            //ʴͺѹ
int     gen;             //Generation
int     nfc;             //ӹǹ駡äӹǳ Fitness
int     maxnfc;          //ӹǹ٧شͧäӹǳ Fitness 


// Problem dependent variables
double	*x, *maxv;	    // Optimized variables x's and maximum velocities (for PSO)
double	*hi, *low;      // boundaries for all dimensions

/***************************************************/

// function automatically evoked by .net studio compiler 2005
// used for handling exception mainly from pow() function
int _matherr( struct _exception *except )
{
	//printf("Exception type = %d\t", except->type);
	//printf("Exception name = %s\n", except->name);
    return 0;    /* Else use the default actions */
}

void test_time()
{
	printf("Current time is %s. Press [Enter] to quit.", gettime()); getchar(); exit(1);
}

int main(int argc, char *argv[])
{
	probnum = 1;

    initialize_system(argc, argv); // to initialize important parameters like NP, D, etc.
	allocate_de_memory();
	
	printf("\nStart time is %s.\n\n", gettime());
	experiment();
	printf("\n\nStop time is %s.\n\n", gettime());

	fprintf(stderr, "Program finishes running. Press [Enter] to end.\n");
	getchar();
    return 0;
}

void initialize_system(int argc, char *argv[])   // 鹵͹ 1 ͧ DE initialize
{
	int i;

	D       = 10;
	maxrun  = MAXRUN;   // ˹ӹǹͺ㹡ѹ maxrun = 50  ˹ main.h
	NP      = 100;

	randomize(); // Start up the random number generator

	// ӡ random 仨Ҥ dimension  >=  dimension ٧ش  ͺѹ > ӹǹͺ٧ش
	if ( D >= MAXDIM || maxrun > MAXRUN ) {
		fprintf(stderr, "Too large D or to much maxrun, program terminated without running.\a");
		getchar(); exit(-1);
	}

	// Prepare optimizer's working variables for the given D
	hi   = (double *)calloc(D, sizeof(double));
	low  = (double *)calloc(D, sizeof(double));
	x    = (double *)calloc(D, sizeof(double));
	maxv = (double *)calloc(D, sizeof(double));

	maxnfc = D * 10000;   // ӹǹ駡äӹǳ Fitness
	logstep2screen = maxnfc / 3;
	logstep2file = maxnfc / MAXLOG;

	// Set search space
	for ( i = 0 ; i < D ; i++ ) { // Benchmark functions
		hi[i]  = maxtab[probnum];
		low[i] = mintab[probnum];
	}
}

void experiment()  //  ˹ Strategy  RAND1B
{
	//mode = RAND1B; 
	stratename = "RAND1B";
			
	// ʴ´ ͧ⨷ѭ  F1-Sphere-DE D=10 NP = 50 MaxNFC=2000 Maxrun=50 Logfile: Logs\D10-1-Sphere
	functName = fname[probnum];
	sprintf(description, "%s-DE", functName);
	sprintf(filename, "logs\\D%d-%s-N%d.txt", D, description, NP);
	printf("\n%s D= %d NP= %d MaxNFC= %d MaxRun= %d\tLogFile: %s\n", 
		description, D, NP, maxnfc, maxrun, filename);

	logcount = 0;
	for( nrun = 0 ; nrun < maxrun; nrun++ )   // Ҩӹǹͺ㹡ѹ¡ Maxrun ѹ
		answers[ nrun ] = de();	     // ¡ DE() 纤ӵͺͺѹ  answers[nrun]
	endnfc[ nrun ] = nfc;
	putchar('\n');
	do_stat(description);
}

/***************************************************
 Part of utilities and statistics
***************************************************/

char *gettime( void )
{
	struct tm *t;
	__time64_t long_time;
	static char buff[30];

	_time64( &long_time );  // Get time as 64-bit integer. Convert to local time.
	t = _localtime64( &long_time ); // Note: _localtime64 deprecated; consider _localetime64_s
	sprintf(buff, "%02d-%02d-%02d.%02d:%02d", t->tm_year%100, t->tm_mon, t->tm_mday, t->tm_hour, t->tm_min);
	return buff;
}

void do_stat(char description[])
{
    int    i, j, nsucc = 0, besti = 0, nmedian, tmpi, nf[MAXRUN];
    double d, sum = 0, sum2 = 0, means, stdev;
	double best = 9e99, worst = -9e99, median, meannshake = 0.0;
	double sr, ans[MAXRUN], tmp;

	//==================================================================
    // Find the best, the worst, the mean and the stdev
	for( i = 0; i < nrun; i++ ) {
        sum += answers[i];
        meannshake += nshake[i]; nshake[i] = 0;
        if ( answers[i] < best  ) best  = answers[ besti = i ];
        if ( answers[i] > worst ) worst = answers[i];
		if ( endnfc[i]  > maxnfc ) endnfc[i] = maxnfc;
    }
    means = sum / nrun;
    meannshake /= nrun;
    for( i = 0; i < nrun; i++ ) {
        d = answers[i] - means;
        sum2 += d * d;
    }
    stdev = sqrt(sum2/nrun);
	sr = (double)nsucc/nrun;

	//==================================================================
	// Sort the answers into the ans array, for calculating the median
	dcopy(nrun, ans, answers);
	for ( i = 0 ; i < nrun-1 ; i++ )
		for ( j = i+1; j < nrun ; j++ )
			if ( ans[j] < ans[i] ) {
				tmp = ans[j]; ans[j] = ans[i]; ans[i] = tmp;
				tmpi = endnfc[j]; endnfc[j] = endnfc[i]; endnfc[i] = tmpi;
			}

	// Search for the median value, care of even/odd value of the 'maxrun'
	nmedian = nrun / 2;
	if ( (nrun%2)==1 ) // odd number of runs
		median = ans[nmedian];
	else // even number of runs, get the average of the two median runs
		median = ( ans[nmedian] + ans[nmedian-1] ) / 2;

	//==================================================================
	// Mainly for CEC2005
	// Sort endnfc[] into nf[]
	for ( i = 0 ; i < nrun ; i++ )   // First, copy endnfc[] into nf[]
		nf[i] = endnfc[i];
	for ( i = 0 ; i < nrun-1 ; i++ ) // Then sort the nf[]
		for ( j = i+1; j < nrun ; j++ )
			if ( nf[j] < nf[i] ) {
				tmpi = nf[j]; nf[j] = nf[i]; nf[i] = tmpi;
			}

	//==================================================================
	// Log summary
	if ( (fo = fopen("summary.txt", "a")) == NULL )
		fprintf(stderr, "Fail to open file summary.txt for writing summary logs. Skipped\n");
	else {
		// D	Funct	Algo	Popsize	Mean	StDev	Best	Worst	Median	SR	MeanShake
		fprintf(fo,     "%d\t%s\t%s\t%d\t%12g\t%12g\t%12g\t%12g\t%12g\t%.02lf\t%.2lf\n", 
			D, functName, stratename, NP, 
			means, stdev, best, worst, median, sr, meannshake);
		fprintf(stderr, "%d\t%s\t%s\t%d\t%12g\t%12g\t%12g\t%12g\t%12g\t%.02lf\t%.2lf\n", 
			D, functName, stratename, NP, 
			means, stdev, best, worst, median, sr, meannshake);
		fclose(fo);
	}

	//==================================================================
	// Log the convergence and final sorted results
	if ( (fo = fopen(filename, "w")) == NULL )
		fprintf(stderr, "Fail to open file %s for writing convergence logs. Skipped\n", filename);
	else {
		fprintf(fo, "NFC\t%s\n", description);
		for ( i = 0 ; i < MAXLOG ; i++ ) {
			fprintf(fo, "%d\t%g\n", lognfc[i], logval[i]/maxrun);
			logval[i] = 0; // clear to avoid side-effects to the next run!
		}
		fputs("Sorted achieved f and nfc\n", fo);
		for ( i = 0 ; i < maxrun ; i++ )
			fprintf(fo, "%d\t%g\t%d\n", i, ans[i], endnfc[i]);

		fclose(fo);
	}

	// Simply clear them for next run, despite no serious side effects
	for ( i = 0 ; i < MAXRUN ; i++ ) {
		ans[i] = 0; nshake[i] = 0; endnfc[i] = 0;
	}
}

void testUniformRandom()
{
	int	i, j, a[10];
	double rr;

	for ( i = 0 ; i < 10; i++ )
		a[i] = 0;

	for ( i = 0 ; i < 500000; i++ ) {
		rr = randreal(0, 100);
		j = (int)rr / 10;
		a[j]++;
		if ( i == 249999 || i == 499999 ) {
			for ( j = 0 ; j < 10; j++ )
				printf("%d\t", a[j]);
			putchar('\n');
		}
	}
}