#ifndef _MAIN_H
#define _MAIN_H

// General constants widely used ==========================
#define TRUE	1
#define FALSE	0
#define E   2.7182818284590452353602874713526625
#define PI  3.1415926535897932384626433832795029

// Running configuration ==================================
#define MAXRUN  100   // no. of runs
#define MAXDIM  100  // max. dimensions
#define MAXPOP  500  // max. population size
#define MAXPROB 8    // max. allowed problems, used for defining ranges
#define MAXLOG  41   // original no. of log steps for convergence

// External variables delclaration ========================
#define better(y1, y2) (y1<y2)  // Objective function (for minimization)
extern int    D, maxrun, maxgen, maxnfc;
extern int    probnum, nrun, gen, nfc;
extern double *x, *maxv, *hi, *low;
extern double mintab[],  maxtab[];
extern double min0tab[], max0tab[];

// Names and Displays
extern char  *fname[];
extern char  *functName;
extern char  *stratename, *mutname;
enum  algo { RAND1B, BEST1B, CUR2BEST2B, RAND2BEST1B, RAND2DIR, 
			CUR2BEST1B, CUR2RAND1B } algorithm;

// For logging purpose
extern int     logcount;
extern int     logstep2screen; // for on screen logging
extern int     logstep2file;	   // for file-based logging
extern double  answers[];
extern int     endnfc[];
extern int     lognfc[];
extern double  logval[];
extern int     logc;
extern FILE    *fout;
extern char    filename[];

// Function prototypes ====================================
int    main(int argc, char *argv[]);
void   initialize_system(int argc, char *argv[]);
void   assign_strategy();
void   experiment();
char   *gettime();
void   do_stat(char description[]);
void   testUniformRandom();

#endif