/* Declaration for random number related variables and routines */

# ifndef _RAND_H
# define _RAND_H

extern long lseed;

/* Function declarations for the random number generator */
void   randomize();
#define unirandom() (uniform_random(&lseed)) // U(0,1)
int    randint(int low, int high);
double randreal(double low, double high);
double uniform_random(long *idum);

// Internal used routines for random generator
void   warmup_random (double seed);
void   advance_random ();
double randomperc();
void   initrandomnormaldeviate();
double noise(double mu, double sigma);
double randomnormaldeviate();

# endif